//
//  Copyright 2011 Canonical Ltd.
//	
//  This program is free software: you can redistribute it and/or modify it
//  under the terms of the GNU Affero General Public License version 3,
//  as published by the Free Software Foundation.
//	
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranties of
//  MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
//  PURPOSE.  See the GNU Affero General Public License for more details.
//
//  You should have received a copy of the GNU Affero General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

#import "UOSSOMusicCredsFetchOperation.h"

#import "URLQueryStringParser.h"


@interface UOSSOMusicCredsFetchOperation ()
@property (copy) NSString *username;
@property (copy) NSString *password;
@end


@implementation UOSSOMusicCredsFetchOperation

@synthesize username, password;

- (void)dealloc;
{
	[username release];
	[password release];
	[super dealloc];
}

- (NSURLRequest *)connection:(NSURLConnection *)connection willSendRequest:(NSURLRequest *)request redirectResponse:(NSURLResponse *)response;
{
	// haven't sent a request yet
	if (response == nil)
		return request;
	
	if ([[[request URL] scheme] isEqualToString:@"x-ubuntuone-music"])
	{
		URLQueryStringParser *queryParser = [[[URLQueryStringParser alloc] initWithURL:[request URL]] autorelease];
		self.username = [queryParser queryStringValueForKey:@"u"];
		self.password = [queryParser queryStringValueForKey:@"p"];

//		[connection cancel];
//		[self finish];
//		return nil;
	}
	return nil;
}

@end
